package de.flothow.prog3.diningsavages;

/**
 * Implementiert einen Wilden als eigenständigen Thread.
 * 
 * @author Sebastian Flothow (sebastian@flothow.de)
 */
public class Savage extends Thread {
	private int i;
	private Pot pot;
	
	/**
	 * Erzeugt einen Wilden, der aus dem angegebenen Topf isst.
	 * 
	 * @param i eindeutige Nummer des Wilden, wird in Ausgaben verwendet
	 * @param pot Topf, aus dem der Wilde isst
	 */
	public Savage(int i, Pot pot) {
		this.i = i;
		this.pot = pot;
	}
	
	/**
	 * Isst aus dem Topf. Nimmt in einer Endlosschleife jeweils eine Portion aus dem Topf und
	 * isst sie. Falls eine Exception auftritt wird diese auf stderr
	 * ausgegeben und der Thread beendet.
	 */
	@Override
	public void run() {
		try {
			while (true) {
				System.out.println("Wilder " + i + " nimmt eine Portion aus dem Topf");
				pot.takeServing();
				
				eat();
			}
		} catch (Exception e) {
			System.err.print("Wilder " + i + ": ");
			e.printStackTrace();
		}
	}	
	
	protected void eat() throws InterruptedException {
		System.out.println("Wilder " + i + " isst");
		Thread.sleep(5000);
	}
}
